XYZ File Manager
Current Path:
/usr/bin
usr
/
bin
/
π
..
π
X11
π
[
(66.89 KB)
π
ab
(58.42 KB)
π
addpart
(30.31 KB)
π
apt
(18.31 KB)
π
apt-cache
(86.38 KB)
π
apt-cdrom
(22.38 KB)
π
apt-config
(26.31 KB)
π
apt-get
(50.38 KB)
π
apt-key
(27.32 KB)
π
apt-mark
(58.38 KB)
π
arch
(42.86 KB)
π
awk
(154.66 KB)
π
b2sum
(58.98 KB)
π
base32
(46.89 KB)
π
base64
(46.89 KB)
π
basename
(42.83 KB)
π
basenc
(54.89 KB)
π
bash
(1.21 MB)
π
bashbug
(6.7 KB)
π
bdftopcf
(42.45 KB)
π
bdftruncate
(10.22 KB)
π
busctl
(90.5 KB)
π
c_rehash
(6.68 KB)
π
captoinfo
(90.34 KB)
π
cat
(42.98 KB)
π
certbot
(958 B)
π
chage
(78.49 KB)
π
chardet
(221 B)
π
chardetect
(221 B)
π
chattr
(14.24 KB)
π
chcon
(67.11 KB)
π
checkgid
(14.23 KB)
π
chfn
(61.2 KB)
π
chgrp
(67.05 KB)
π
chmod
(62.98 KB)
π
choom
(54.31 KB)
π
chown
(71.05 KB)
π
chrt
(66.31 KB)
π
chsh
(51.64 KB)
π
cksum
(139.05 KB)
π
clear
(14.24 KB)
π
clear_console
(14.15 KB)
π
cmp
(50.95 KB)
π
comm
(46.92 KB)
π
corelist
(15.01 KB)
π
cp
(147.61 KB)
π
cpan
(8.16 KB)
π
cpan5.36-x86_64-linux-gnu
(8.18 KB)
π
csplit
(119.17 KB)
π
ctstat
(26.59 KB)
π
cut
(46.98 KB)
π
dash
(122.7 KB)
π
date
(119.05 KB)
π
dbus-cleanup-sockets
(14.22 KB)
π
dbus-daemon
(238.56 KB)
π
dbus-monitor
(26.23 KB)
π
dbus-run-session
(14.23 KB)
π
dbus-send
(30.22 KB)
π
dbus-update-activation-environment
(14.22 KB)
π
dbus-uuidgen
(14.22 KB)
π
dd
(87.15 KB)
π
deb-systemd-helper
(23.79 KB)
π
deb-systemd-invoke
(6.09 KB)
π
debconf
(2.79 KB)
π
debconf-apt-progress
(11.27 KB)
π
debconf-communicate
(608 B)
π
debconf-copydb
(1.68 KB)
π
debconf-escape
(647 B)
π
debconf-set-selections
(2.92 KB)
π
debconf-show
(1.78 KB)
π
delpart
(30.31 KB)
π
df
(99.8 KB)
π
dialog
(247.85 KB)
π
diff
(151.58 KB)
π
diff3
(67.14 KB)
π
dir
(147.8 KB)
π
dircolors
(50.92 KB)
π
dirname
(38.83 KB)
π
dmesg
(86.58 KB)
π
dnsdomainname
(22.15 KB)
π
domainname
(22.15 KB)
π
dpkg
(310.64 KB)
π
dpkg-deb
(166.52 KB)
π
dpkg-divert
(154.55 KB)
π
dpkg-maintscript-helper
(20.71 KB)
π
dpkg-query
(158.58 KB)
π
dpkg-realpath
(4.09 KB)
π
dpkg-split
(126.48 KB)
π
dpkg-statoverride
(62.33 KB)
π
dpkg-trigger
(86.48 KB)
π
du
(171.33 KB)
π
dvipdf
(1007 B)
π
echo
(42.83 KB)
π
editor
(3.48 MB)
π
egrep
(41 B)
π
enc2xs
(40.96 KB)
π
encguess
(3 KB)
π
env
(47.4 KB)
π
eps2eps
(639 B)
π
ex
(3.48 MB)
π
expand
(42.92 KB)
π
expiry
(30.45 KB)
π
expr
(115.05 KB)
π
factor
(83.2 KB)
π
faillog
(22.53 KB)
π
fallocate
(34.31 KB)
π
false
(34.83 KB)
π
fcgistarter
(14.23 KB)
π
fgrep
(41 B)
π
fincore
(34.36 KB)
π
find
(219.58 KB)
π
findmnt
(83.59 KB)
π
flock
(34.39 KB)
π
fmt
(46.89 KB)
π
fold
(42.89 KB)
π
fonttosfnt
(34.41 KB)
π
free
(26.3 KB)
π
fuser
(39.83 KB)
π
getconf
(26.5 KB)
π
getent
(35.47 KB)
π
getopt
(34.31 KB)
π
ghostscript
(14.23 KB)
π
gpasswd
(86.42 KB)
π
gpgv
(463 KB)
π
grep
(198.39 KB)
π
groups
(42.89 KB)
π
gs
(14.23 KB)
π
gsbj
(350 B)
π
gsdj
(352 B)
π
gsdj500
(352 B)
π
gslj
(353 B)
π
gslp
(350 B)
π
gsnd
(277 B)
π
gunzip
(2.29 KB)
π
gzexe
(6.3 KB)
π
gzip
(95.84 KB)
π
h2ph
(28.54 KB)
π
h2xs
(59.51 KB)
π
hardlink
(50.39 KB)
π
head
(46.95 KB)
π
helpztags
(2.46 KB)
π
hostid
(38.83 KB)
π
hostname
(22.15 KB)
π
hostnamectl
(30.38 KB)
π
htcacheclean
(34.24 KB)
π
htdbm
(26.23 KB)
π
htdigest
(14.23 KB)
π
htpasswd
(26.23 KB)
π
i386
(26.58 KB)
π
iconv
(63.13 KB)
π
id
(47.02 KB)
π
infocmp
(62.31 KB)
π
infotocap
(90.34 KB)
π
install
(155.8 KB)
π
instmodsh
(4.27 KB)
π
ionice
(34.31 KB)
π
ip
(674.82 KB)
π
ipcmk
(34.38 KB)
π
ipcrm
(34.31 KB)
π
ipcs
(74.31 KB)
π
ischroot
(14.32 KB)
π
join
(54.98 KB)
π
journalctl
(74.64 KB)
π
json_pp
(4.88 KB)
π
kernel-install
(12.75 KB)
π
kill
(22.3 KB)
π
killall
(31.95 KB)
π
last
(50.31 KB)
π
lastb
(50.31 KB)
π
lastlog
(31.75 KB)
π
lcf
(7.6 KB)
π
ld.so
(205.96 KB)
π
ldd
(5.28 KB)
π
letsencrypt
(958 B)
π
libnetcfg
(15.41 KB)
π
link
(38.83 KB)
π
linux32
(26.58 KB)
π
linux64
(26.58 KB)
π
ln
(71.12 KB)
π
lnstat
(26.59 KB)
π
locale
(46.16 KB)
π
localectl
(26.38 KB)
π
localedef
(291.91 KB)
π
logger
(54.9 KB)
π
login
(51.78 KB)
π
loginctl
(58.48 KB)
π
logname
(38.83 KB)
π
logresolve
(14.24 KB)
π
ls
(147.8 KB)
π
lsattr
(14.24 KB)
π
lsb_release
(2.59 KB)
π
lsblk
(202.31 KB)
π
lscpu
(126.31 KB)
π
lsfd
(120.3 KB)
π
lsipc
(98.31 KB)
π
lsirq
(34.48 KB)
π
lslocks
(70.7 KB)
π
lslogins
(94.31 KB)
π
lsmem
(66.31 KB)
π
lsns
(82.31 KB)
π
mawk
(154.66 KB)
π
mcookie
(34.38 KB)
π
md5sum
(50.95 KB)
π
md5sum.textutils
(50.95 KB)
π
mesg
(18.3 KB)
π
mkdir
(95.27 KB)
π
mkfifo
(67.17 KB)
π
mkfontdir
(65 B)
π
mkfontscale
(39.05 KB)
π
mknod
(71.2 KB)
π
mktemp
(42.92 KB)
π
more
(58.31 KB)
π
mount
(58.3 KB)
π
mountpoint
(18.3 KB)
π
mv
(139.62 KB)
π
namei
(34.31 KB)
π
nawk
(154.66 KB)
π
netstat
(151.66 KB)
π
networkctl
(106.38 KB)
π
newgrp
(47.75 KB)
π
nice
(42.86 KB)
π
nisdomainname
(22.15 KB)
π
nl
(111.11 KB)
π
nohup
(42.89 KB)
π
normalizer
(244 B)
π
nproc
(42.89 KB)
π
nsenter
(34.54 KB)
π
nstat
(104.45 KB)
π
numfmt
(67.02 KB)
π
od
(79.02 KB)
π
openssl
(953.26 KB)
π
pager
(58.31 KB)
π
paperconf
(14.34 KB)
π
partx
(118.31 KB)
π
passwd
(66.65 KB)
π
paste
(42.89 KB)
π
pathchk
(42.86 KB)
π
pdb3
(62.4 KB)
π
pdb3.11
(62.4 KB)
π
pdf2dsc
(698 B)
π
pdf2ps
(909 B)
π
peekfd
(14.5 KB)
π
perl
(3.63 MB)
π
perl5.36-x86_64-linux-gnu
(14.41 KB)
π
perl5.36.0
(3.63 MB)
π
perlbug
(44.12 KB)
π
perldoc
(125 B)
π
perlivp
(10.61 KB)
π
perlthanks
(44.12 KB)
π
pf2afm
(498 B)
π
pfbtopfa
(516 B)
π
pgrep
(34.42 KB)
π
phar
(14.88 KB)
π
phar.phar
(14.88 KB)
π
phar.phar8.2
(14.88 KB)
π
phar8.2
(14.88 KB)
π
phar8.2.phar
(14.88 KB)
π
php
(5.4 MB)
π
php8.2
(5.4 MB)
π
piconv
(8.16 KB)
π
pidof
(26.31 KB)
π
pidwait
(34.42 KB)
π
pinky
(47.05 KB)
π
pkill
(34.42 KB)
π
pl2pm
(4.43 KB)
π
pldd
(22.69 KB)
π
pmap
(34.34 KB)
π
pod2html
(4.04 KB)
π
pod2man
(14.68 KB)
π
pod2text
(10.55 KB)
π
pod2usage
(4.01 KB)
π
podchecker
(3.57 KB)
π
pphs
(404 B)
π
pr
(79.11 KB)
π
printafm
(395 B)
π
printenv
(34.83 KB)
π
printf
(62.92 KB)
π
prlimit
(38.83 KB)
π
prove
(13.34 KB)
π
prtstat
(18.57 KB)
π
ps
(142.93 KB)
π
ps2ascii
(631 B)
π
ps2epsi
(1.23 KB)
π
ps2pdf
(272 B)
π
ps2pdf12
(215 B)
π
ps2pdf13
(215 B)
π
ps2pdf14
(215 B)
π
ps2pdfwr
(1.05 KB)
π
ps2ps
(647 B)
π
ps2ps2
(669 B)
π
ps2txt
(631 B)
π
pslog
(14.45 KB)
π
pstree
(35.78 KB)
π
pstree.x11
(35.78 KB)
π
ptar
(3.48 KB)
π
ptardiff
(2.58 KB)
π
ptargrep
(4.29 KB)
π
ptx
(135.23 KB)
π
pwd
(42.92 KB)
π
pwdx
(14.3 KB)
π
py3clean
(7.63 KB)
π
py3compile
(13 KB)
π
py3versions
(12.52 KB)
π
pydoc3
(79 B)
π
pydoc3.11
(79 B)
π
pygettext3
(23.67 KB)
π
pygettext3.11
(23.67 KB)
π
python3
(6.52 MB)
π
python3.11
(6.52 MB)
π
rbash
(1.21 MB)
π
rdma
(180.6 KB)
π
readlink
(50.89 KB)
π
realpath
(50.92 KB)
π
rename.ul
(22.3 KB)
π
renice
(14.3 KB)
π
reset
(30.24 KB)
π
resizepart
(70.31 KB)
π
rev
(14.3 KB)
π
rgrep
(30 B)
π
rm
(71.05 KB)
π
rmdir
(54.92 KB)
π
rotatelogs
(26.31 KB)
π
routel
(1.62 KB)
π
rtstat
(26.59 KB)
π
run-parts
(26.91 KB)
π
runcon
(42.95 KB)
π
rview
(3.48 MB)
π
rvim
(3.48 MB)
π
savelog
(10.24 KB)
π
scp
(266.63 KB)
π
script
(70.3 KB)
π
scriptlive
(54.3 KB)
π
scriptreplay
(46.3 KB)
π
sdiff
(55.08 KB)
π
sed
(123.46 KB)
π
select-editor
(2.39 KB)
π
sensible-browser
(1.26 KB)
π
sensible-editor
(1.24 KB)
π
sensible-pager
(565 B)
π
seq
(58.92 KB)
π
setarch
(26.58 KB)
π
setpriv
(78.31 KB)
π
setsid
(14.3 KB)
π
setterm
(46.31 KB)
π
sftp
(282.59 KB)
π
sg
(47.75 KB)
π
sh
(122.7 KB)
π
sha1sum
(54.95 KB)
π
sha224sum
(58.95 KB)
π
sha256sum
(58.95 KB)
π
sha384sum
(62.95 KB)
π
sha512sum
(62.95 KB)
π
shasum
(9.75 KB)
π
shred
(63.14 KB)
π
shuf
(58.98 KB)
π
skill
(30.33 KB)
π
slabtop
(22.37 KB)
π
sleep
(42.86 KB)
π
slogin
(1.07 MB)
π
snice
(30.33 KB)
π
sort
(115.68 KB)
π
splain
(18.99 KB)
π
split
(59.55 KB)
π
ss
(189.14 KB)
π
ssh
(1.07 MB)
π
ssh-add
(518.44 KB)
π
ssh-agent
(474.38 KB)
π
ssh-argv0
(1.42 KB)
π
ssh-copy-id
(12.38 KB)
π
ssh-keygen
(646.44 KB)
π
ssh-keyscan
(622.47 KB)
π
stat
(95.2 KB)
π
stdbuf
(58.92 KB)
π
streamzip
(7.75 KB)
π
stty
(83.02 KB)
π
su
(70.31 KB)
π
sum
(50.96 KB)
π
sync
(38.89 KB)
π
systemctl
(1.29 MB)
π
systemd
(90.38 KB)
π
systemd-analyze
(182.61 KB)
π
systemd-ask-password
(18.48 KB)
π
systemd-cat
(18.38 KB)
π
systemd-cgls
(22.48 KB)
π
systemd-cgtop
(38.4 KB)
π
systemd-creds
(42.61 KB)
π
systemd-cryptenroll
(58.6 KB)
π
systemd-delta
(26.38 KB)
π
systemd-detect-virt
(18.37 KB)
π
systemd-escape
(18.37 KB)
π
systemd-firstboot
(50.59 KB)
π
systemd-id128
(22.37 KB)
π
systemd-inhibit
(22.39 KB)
π
systemd-machine-id-setup
(18.48 KB)
π
systemd-mount
(50.59 KB)
π
systemd-notify
(18.38 KB)
π
systemd-path
(18.37 KB)
π
systemd-repart
(150.69 KB)
π
systemd-run
(58.57 KB)
π
systemd-socket-activate
(26.38 KB)
π
systemd-stdio-bridge
(18.38 KB)
π
systemd-sysext
(42.49 KB)
π
systemd-sysusers
(62.68 KB)
π
systemd-tmpfiles
(110.57 KB)
π
systemd-tty-ask-password-agent
(34.38 KB)
π
systemd-umount
(50.59 KB)
π
tabs
(18.23 KB)
π
tac
(111.05 KB)
π
tail
(75.14 KB)
π
tar
(519.52 KB)
π
taskset
(62.31 KB)
π
tee
(42.95 KB)
π
tempfile
(14.18 KB)
π
test
(58.89 KB)
π
tic
(90.34 KB)
π
timedatectl
(42.37 KB)
π
timeout
(47.49 KB)
π
tload
(18.32 KB)
π
toe
(22.23 KB)
π
top
(131.58 KB)
π
touch
(107.05 KB)
π
tput
(26.27 KB)
π
tr
(54.89 KB)
π
true
(34.83 KB)
π
truncate
(42.89 KB)
π
tset
(30.24 KB)
π
tsort
(54.89 KB)
π
tty
(34.86 KB)
π
tzselect
(14.99 KB)
π
ucf
(40.69 KB)
π
ucfq
(18.91 KB)
π
ucfr
(10.85 KB)
π
uclampset
(62.31 KB)
π
ucs2any
(18.32 KB)
π
umount
(34.3 KB)
π
uname
(42.86 KB)
π
uncompress
(2.29 KB)
π
unexpand
(42.92 KB)
π
uniq
(46.95 KB)
π
unlink
(38.83 KB)
π
unshare
(82.54 KB)
π
update-alternatives
(58.31 KB)
π
update-mime-database
(59.27 KB)
π
uptime
(14.3 KB)
π
users
(38.89 KB)
π
utmpdump
(30.3 KB)
π
vdir
(147.8 KB)
π
vi
(3.48 MB)
π
view
(3.48 MB)
π
vim
(3.48 MB)
π
vim.basic
(3.48 MB)
π
vimdiff
(3.48 MB)
π
vimtutor
(2.1 KB)
π
vmstat
(34.72 KB)
π
w
(22.3 KB)
π
wall
(38.3 KB)
π
watch
(26.71 KB)
π
wc
(51.05 KB)
π
wdctl
(70.34 KB)
π
wget
(527.36 KB)
π
whereis
(30.77 KB)
π
which
(946 B)
π
which.debianutils
(946 B)
π
who
(59.02 KB)
π
whoami
(38.86 KB)
π
x86_64
(26.58 KB)
π
xargs
(70.45 KB)
π
xdg-user-dir
(234 B)
π
xdg-user-dirs-update
(26.16 KB)
π
xsubpp
(5.05 KB)
π
xxd
(18.21 KB)
π
yes
(38.83 KB)
π
ypdomainname
(22.15 KB)
π
zcat
(1.94 KB)
π
zcmp
(1.64 KB)
π
zdiff
(6.31 KB)
π
zdump
(22.52 KB)
π
zegrep
(29 B)
π
zfgrep
(29 B)
π
zforce
(2.03 KB)
π
zgrep
(7.91 KB)
π
zipdetails
(68.55 KB)
π
zless
(2.15 KB)
π
zmore
(1.8 KB)
π
znew
(4.47 KB)
Editing: kernel-install
#!/bin/sh # -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*- # ex: ts=8 sw=4 sts=4 et filetype=sh # SPDX-License-Identifier: LGPL-2.1-or-later # # This file is part of systemd. # # systemd is free software; you can redistribute it and/or modify it # under the terms of the GNU Lesser General Public License as published by # the Free Software Foundation; either version 2.1 of the License, or # (at your option) any later version. # # systemd is distributed in the hope that it will be useful, but # WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU # General Public License for more details. # # You should have received a copy of the GNU Lesser General Public License # along with systemd; If not, see <https://www.gnu.org/licenses/>. skip_remaining=77 set -e usage() { echo "Usage:" echo " kernel-install [OPTIONS...] add KERNEL-VERSION KERNEL-IMAGE [INITRD-FILE...]" echo " kernel-install [OPTIONS...] remove KERNEL-VERSION" echo " kernel-install [OPTIONS...] inspect" echo "Options:" echo " -h, --help Print this help and exit" echo " --version Print version string and exit" echo " -v, --verbose Increase verbosity" } dropindirs_sort() { suffix="$1" shift for d; do for i in "$d/"*"$suffix"; do [ -e "$i" ] && echo "${i##*/}" done done | sort -Vu | while read -r f; do for d; do if [ -e "$d/$f" ]; then [ -x "$d/$f" ] && echo "$d/$f" continue 2 fi done done } export LC_COLLATE=C for i; do if [ "$i" = "--help" ] || [ "$i" = "-h" ]; then usage exit 0 fi done for i; do if [ "$i" = "--version" ]; then echo "kernel-install 252 (252.33-1~deb12u1)" exit 0 fi done if [ "$KERNEL_INSTALL_BYPASS" = "1" ]; then echo "kernel-install: Skipping execution because KERNEL_INSTALL_BYPASS=1" exit 0 fi export KERNEL_INSTALL_VERBOSE=0 if [ "$1" = "--verbose" ] || [ "$1" = "-v" ]; then shift export KERNEL_INSTALL_VERBOSE=1 log_verbose() { printf "%s\n" "$*"; } else log_verbose() { :; } fi if [ "${0##*/}" = "installkernel" ]; then COMMAND=add # kernel's install.sh invokes us as # /sbin/installkernel <version> <vmlinuz> <map> <installation-dir> # We ignore the last two arguments. set -- "${1:?}" "${2:?}" else COMMAND="$1" [ $# -ge 1 ] && shift fi if [ "$COMMAND" = "inspect" ]; then KERNEL_VERSION="" else if [ $# -lt 1 ]; then echo "Error: not enough arguments" >&2 exit 1 fi KERNEL_VERSION="$1" shift fi # These two settings are only settable via install.conf layout= initrd_generator= # These two settings can be inherited from the environment _MACHINE_ID_SAVED="$MACHINE_ID" _BOOT_ROOT_SAVED="$BOOT_ROOT" if [ -n "$KERNEL_INSTALL_CONF_ROOT" ]; then install_conf="$KERNEL_INSTALL_CONF_ROOT/install.conf" elif [ -f "/etc/kernel/install.conf" ]; then install_conf="/etc/kernel/install.conf" elif [ -f "/usr/lib/kernel/install.conf" ]; then install_conf="/usr/lib/kernel/install.conf" else install_conf= fi if [ -f "$install_conf" ]; then log_verbose "Reading $install_confβ¦" # shellcheck source=/dev/null . "$install_conf" fi [ -n "$layout" ] && log_verbose "$install_conf configures layout=$layout" [ -n "$initrd_generator" ] && \ log_verbose "$install_conf configures initrd_generator=$initrd_generator" if [ -n "$_MACHINE_ID_SAVED" ]; then MACHINE_ID="$_MACHINE_ID_SAVED" log_verbose "MACHINE_ID=$MACHINE_ID set via environment" else [ -n "$MACHINE_ID" ] && log_verbose "MACHINE_ID=$MACHINE_ID set via install.conf" fi if [ -n "$_BOOT_ROOT_SAVED" ]; then BOOT_ROOT="$_BOOT_ROOT_SAVED" log_verbose "BOOT_ROOT=$BOOT_ROOT set via environment" else [ -n "$BOOT_ROOT" ] && log_verbose "BOOT_ROOT=$BOOT_ROOT set via install.conf" fi # If /etc/machine-id is initialized we'll use it, otherwise we'll use a freshly # generated one. If the user configured an explicit machine ID to use in # /etc/machine-info to use for our purpose, we'll use that instead (for # compatibility). # shellcheck source=/dev/null if [ -z "$MACHINE_ID" ] && [ -f /etc/machine-info ]; then . /etc/machine-info MACHINE_ID="$KERNEL_INSTALL_MACHINE_ID" [ -n "$MACHINE_ID" ] && \ log_verbose "machine-id $MACHINE_ID acquired from /etc/machine-info" fi if [ -z "$MACHINE_ID" ] && [ -s /etc/machine-id ]; then read -r MACHINE_ID </etc/machine-id [ "$MACHINE_ID" = "uninitialized" ] && unset MACHINE_ID [ -n "$MACHINE_ID" ] && \ log_verbose "machine-id $MACHINE_ID acquired from /etc/machine-id" fi if [ -z "$MACHINE_ID" ]; then MACHINE_ID="$(systemd-id128 new)" || exit 1 log_verbose "new machine-id $MACHINE_ID generated" fi # Now that we determined the machine ID to use, let's determine the "token" for # the boot loader entry to generate. We use that for naming the directory below # $BOOT where we want to place the kernel/initrd and related resources, as well # for naming the .conf boot loader spec entry. Typically this is just the # machine ID, but it can be anything else, too, if we are told so. ENTRY_TOKEN_FILE="${KERNEL_INSTALL_CONF_ROOT:-/etc/kernel}/entry-token" if [ -z "$ENTRY_TOKEN" ] && [ -f "$ENTRY_TOKEN_FILE" ]; then read -r ENTRY_TOKEN <"$ENTRY_TOKEN_FILE" log_verbose "entry-token \"$ENTRY_TOKEN\" acquired from $ENTRY_TOKEN_FILE" fi if [ -z "$ENTRY_TOKEN" ]; then # If not configured explicitly, then use a few candidates: the machine ID, # the IMAGE_ID= and ID= fields from /etc/os-release and finally the fixed # string "Default" ENTRY_TOKEN_SEARCH="$MACHINE_ID" # shellcheck source=/dev/null [ -f /etc/os-release ] && . /etc/os-release [ -n "$IMAGE_ID" ] && ENTRY_TOKEN_SEARCH="$ENTRY_TOKEN_SEARCH $IMAGE_ID" [ -n "$ID" ] && ENTRY_TOKEN_SEARCH="$ENTRY_TOKEN_SEARCH $ID" ENTRY_TOKEN_SEARCH="$ENTRY_TOKEN_SEARCH Default" else ENTRY_TOKEN_SEARCH="$ENTRY_TOKEN" fi log_verbose "Entry-token candidates: $ENTRY_TOKEN_SEARCH" # NB: The $MACHINE_ID is guaranteed to be a valid machine ID, but # $ENTRY_TOKEN can be any string that fits into a VFAT filename, though # typically is just the machine ID. if [ -n "$BOOT_ROOT" ]; then # If this was already configured, don't try to guess BOOT_ROOT_SEARCH="$BOOT_ROOT" else BOOT_ROOT_SEARCH="/efi /boot /boot/efi" fi for pref in $BOOT_ROOT_SEARCH; do for suff in $ENTRY_TOKEN_SEARCH; do if [ -d "$pref/$suff" ]; then [ -z "$BOOT_ROOT" ] && BOOT_ROOT="$pref" [ -z "$ENTRY_TOKEN" ] && ENTRY_TOKEN="$suff" log_verbose "$pref/$suff exists, using BOOT_ROOT=$BOOT_ROOT, ENTRY_TOKEN=$ENTRY_TOKEN" break 2 else [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "$pref/$suff not foundβ¦" fi if [ -d "$pref/loader/entries" ]; then [ -z "$BOOT_ROOT" ] && BOOT_ROOT="$pref" log_verbose "$pref/loader/entries exists, using BOOT_ROOT=$BOOT_ROOT" break 2 else log_verbose "$pref/loader/entries not foundβ¦" fi done done [ -z "$BOOT_ROOT" ] && for pref in "/efi" "/boot/efi"; do if mountpoint -q "$pref"; then BOOT_ROOT="$pref" log_verbose "$pref is a mount point, using BOOT_ROOT=$BOOT_ROOT" break else log_verbose "$pref is not a mount pointβ¦" fi done if [ -z "$BOOT_ROOT" ]; then BOOT_ROOT="/boot" [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \ echo "KERNEL_INSTALL_BOOT_ROOT autodection yielded no candidates, using \"$BOOT_ROOT\"" fi if [ -z "$ENTRY_TOKEN" ]; then ENTRY_TOKEN="$MACHINE_ID" [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \ echo "No entry-token candidate matched, using \"$ENTRY_TOKEN\" from machine-id" fi if [ -z "$layout" ]; then # No layout configured by the administrator. Let's try to figure it out # automatically from metadata already contained in $BOOT_ROOT. if [ -e "$BOOT_ROOT/loader/entries.srel" ]; then read -r ENTRIES_SREL <"$BOOT_ROOT/loader/entries.srel" if [ "$ENTRIES_SREL" = "type1" ]; then # The loader/entries.srel file clearly indicates that the installed # boot loader implements the proper standard upstream boot loader # spec for Type #1 entries. Let's default to that, then. layout="bls" else # The loader/entries.srel file indicates some other spec is # implemented and owns the /loader/entries/ directory. Since we # have no idea what that means, let's stay away from it by default. layout="other" fi [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \ echo "$BOOT_ROOT/loader/entries.srel with '$ENTRIES_SREL' found, using layout=$layout" elif [ -d "$BOOT_ROOT/$ENTRY_TOKEN" ]; then # If the metadata in $BOOT_ROOT doesn't tell us anything, then check if # the entry token directory already exists. If so, let's assume it's # the standard boot loader spec, too. layout="bls" log_verbose "$BOOT_ROOT/$ENTRY_TOKEN exists, using layout=$layout" else # There's no metadata in $BOOT_ROOT, and apparently no entry token # directory installed? Then we really don't know anything. layout="other" log_verbose "Entry-token directory not found, using layout=$layout" fi fi ENTRY_DIR_ABS="$BOOT_ROOT/$ENTRY_TOKEN/$KERNEL_VERSION" log_verbose "Using ENTRY_DIR_ABS=$ENTRY_DIR_ABS" # Provide a directory where to store generated initrds cleanup() { [ -n "$KERNEL_INSTALL_STAGING_AREA" ] && rm -rf "$KERNEL_INSTALL_STAGING_AREA" } trap cleanup EXIT KERNEL_INSTALL_STAGING_AREA="$(mktemp -d -t kernel-install.staging.XXXXXXX)" export KERNEL_INSTALL_MACHINE_ID="$MACHINE_ID" export KERNEL_INSTALL_ENTRY_TOKEN="$ENTRY_TOKEN" export KERNEL_INSTALL_BOOT_ROOT="$BOOT_ROOT" export KERNEL_INSTALL_LAYOUT="$layout" export KERNEL_INSTALL_INITRD_GENERATOR="$initrd_generator" export KERNEL_INSTALL_STAGING_AREA MAKE_ENTRY_DIR_ABS=0 [ "$layout" = "bls" ] || MAKE_ENTRY_DIR_ABS=1 ret=0 if [ -z "$KERNEL_INSTALL_PLUGINS" ]; then KERNEL_INSTALL_PLUGINS="$( dropindirs_sort ".install" \ "/etc/kernel/install.d" \ "/usr/lib/kernel/install.d" )" fi if [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ]; then printf '%s\n' "Plugin files:" for f in $KERNEL_INSTALL_PLUGINS; do printf '%s\n' "$f" done fi case "$COMMAND" in add) if [ $# -lt 1 ]; then echo "Error: command 'add' requires a kernel image" >&2 exit 1 fi if ! [ -f "$1" ]; then echo "Error: kernel image argument $1 not a file" >&2 exit 1 fi if [ "$MAKE_ENTRY_DIR_ABS" -eq 0 ]; then # Compatibility with earlier versions that used the presence of $BOOT_ROOT/$ENTRY_TOKEN # to signal to 00-entry-directory to create $ENTRY_DIR_ABS # to serve as the indication to use or to not use the BLS if [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ]; then echo "+mkdir -v -p $ENTRY_DIR_ABS" mkdir -v -p "$ENTRY_DIR_ABS" || exit 1 else mkdir -p "$ENTRY_DIR_ABS" || exit 1 fi fi for f in $KERNEL_INSTALL_PLUGINS; do log_verbose "+$f add $KERNEL_VERSION $ENTRY_DIR_ABS" "$@" err=0 "$f" add "$KERNEL_VERSION" "$ENTRY_DIR_ABS" "$@" || err=$? [ $err -eq $skip_remaining ] && break [ $err -ne 0 ] && exit $err done ;; remove) for f in $KERNEL_INSTALL_PLUGINS; do log_verbose "+$f remove $KERNEL_VERSION $ENTRY_DIR_ABS" err=0 "$f" remove "$KERNEL_VERSION" "$ENTRY_DIR_ABS" || err=$? [ $err -eq $skip_remaining ] && break [ $err -ne 0 ] && exit $err done if [ "$MAKE_ENTRY_DIR_ABS" -eq 0 ]; then log_verbose "Removing $ENTRY_DIR_ABS/" rm -rf "$ENTRY_DIR_ABS" fi ;; inspect) echo "KERNEL_INSTALL_MACHINE_ID: $KERNEL_INSTALL_MACHINE_ID" echo "KERNEL_INSTALL_ENTRY_TOKEN: $KERNEL_INSTALL_ENTRY_TOKEN" echo "KERNEL_INSTALL_BOOT_ROOT: $KERNEL_INSTALL_BOOT_ROOT" echo "KERNEL_INSTALL_LAYOUT: $KERNEL_INSTALL_LAYOUT" echo "KERNEL_INSTALL_INITRD_GENERATOR: $KERNEL_INSTALL_INITRD_GENERATOR" echo "ENTRY_DIR_ABS: $KERNEL_INSTALL_BOOT_ROOT/$ENTRY_TOKEN/\$KERNEL_VERSION" # Assert that ENTRY_DIR_ABS actually matches what we are printing here [ "${ENTRY_DIR_ABS%/*}" = "$KERNEL_INSTALL_BOOT_ROOT/$ENTRY_TOKEN" ] || { echo "Assertion didn't pass." >&2; exit 1; } ;; *) echo "Error: unknown command '$COMMAND'" >&2 exit 1 ;; esac exit "$ret"
Upload File
Create Folder